<?php
/*
 * Copyright (C) 2007, M2X
 *
 * Authors: Jean-Paul Saman
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
 *****************************************************************************/

function timesheets($type)
{
GLOBAL $AppUI, $canRead, $canEdit, $canDelete;

if (!$canRead) {			// lock out users that do not have at least readPermission on this module
	$AppUI->redirect( "m=public&a=access_denied" );
}
//prepare an html table with a head section
?>
<table width="100%" border="0" cellpadding="2" cellspacing="1" class="tbl">
<tr>
	<th nowrap="nowrap">&nbsp;</th>
	<th nowrap="nowrap"><?php echo $AppUI->_( 'Date' );?></th>
	<th nowrap="nowrap"><?php echo $AppUI->_( 'Month' );?></th>
	<th nowrap="nowrap"><?php echo $AppUI->_( 'Worked' );?></th>
	<th nowrap="nowrap"><?php echo $AppUI->_( 'Submitter' );?></th>
	<th nowrap="nowrap"><?php echo $AppUI->_( 'Status' );?></th>
	<th nowrap="nowrap">&nbsp;</th>
</tr>
<?php
// Retrieve the list of users that may access this module.
if(isset($_REQUEST["user_filter_id"])){
	$AppUI->setState("user_filter_id", $_REQUEST["user_filter_id"]);
	$user_filter_id = $_REQUEST["user_filter_id"];
} else {
	$user_filter_id = $AppUI->getState('user_filter_id');
	if (!isset($user_filter_id)) {
		$user_filter_id = $AppUI->user_id;
		$AppUI->setState('user_filter_id', $user_filter_id);
	}
}

$perms =& $AppUI->acl();
if ($canDelete) {
	$user_list = array( 0 => $AppUI->_("All", UI_OUTPUT_RAW)) + $perms->getPermittedUsers("timesheet");
}
else {
	$user_list = array( ) + $perms->getPermittedUsers("timesheet");
}
$user_combo = arraySelect($user_list, "user_filter_id", "class='text' onchange='javascript:document.searchform.submit()'", $user_filter_id, false);

echo "<tr><form name='searchform' action='?m=timesheet' method='post'>
	".$AppUI->_("Show timesheets for ").": $user_combo
        </form></tr>";

// Pull all users
$q = new DBQuery;
$q->addQuery('user_id, contact_first_name, contact_last_name');
$q->addTable('users');
$q->addTable('contacts');
$q->addWhere('user_contact = contact_id');
$q->addOrder('contact_last_name, contact_first_name');
$q->exec();
$users = array();
while ( $row = $q->fetchRow()) {
  $users[$row['user_id']] = $row['contact_last_name'] . ', ' . $row['contact_first_name'];
}

$q->Clear();
$q->addQuery('timesheet_id, timesheet_date, timesheet_status, timesheet_period, timesheet_creator, timesheet_worked');
$q->addTable('timesheet');
if ($user_filter_id > 0) {
	$q->addWhere('timesheet_creator = ' . $user_filter_id );
}
else {
	$q->addOrder('timesheet_creator');
}
$q->addOrder('timesheet_period');

if ($type >= 0)
	$q->addWhere('timesheet_status = '. $type );
$month = $q->loadList();

// add/show now gradually the timesheet
foreach ($month as $row) {
?>
<tr>
	<td nowrap="nowrap" width="20">
	<?php if (($canEdit) && ($row["timesheet_status"]) < 1) {
		// call the edit site with the unique id of the timesheet item
		echo "\n".'<a href="?m=timesheet&a=addedit&timesheet_id=' . $row["timesheet_id"] . '">';
		echo dPshowImage( './images/icons/stock_edit-16.png', '16', '16' );
		echo "\n</a>";
	}
	?>
	</td>
	<td> <?php 
		$date = new CDate();
		$date->setDate($row["timesheet_date"],DATE_FORMAT_UNIXTIME);
		echo '<a href="?m=timesheet&a=addedit&timesheet_id=' . $row["timesheet_id"] . '">';
		echo $date->format( FMT_TIMESTAMP_DATE );
		echo "</a>";
	      ?> </td>
	<td> <?php 
		echo "\n".'<a href="?m=timesheet&a=addedit&timesheet_id=' . $row["timesheet_id"] . '">';
		$month = new CDate();
		$month->setMonth($row["timesheet_period"]);
		if ($month->GetMonth() == 1)
			echo dPformSafe('January');
		else if ($month->getMonth() == 2)
			echo dPformSafe('February');
		else if ($month->getMonth() == 3)
			echo dPformSafe('March');
		else if ($month->getMonth() == 4)
			echo dPformSafe('April');
		else if ($month->getMonth() == 5)
			echo dPformSafe('May');
		else if ($month->getMonth() == 6)
			echo dPformSafe('June');
		else if ($month->getMonth() == 7)
			echo dPformSafe('July');
		else if ($month->getMonth() == 8)
			echo dPformSafe('August');
		else if ($month->getMonth() == 9)
			echo dPformSafe('September');
		else if ($month->getMonth() == 10)
			echo dPformSafe('October');
		else if ($month->getMonth() == 11)
			echo dPformSafe('November');
		else if ($month->getMonth() == 12)
			echo dPformSafe('December');
		echo "\n</a>";
	     ?>
        </td>
	<td> <?php echo $row["timesheet_worked"]; ?> </td>
	<td> <?php echo $users[$row["timesheet_creator"]]; ?> </td>
	<td> <?php 
		$status = $row["timesheet_status"]; 
		if ($status == 0)
			echo dPformSafe("Open for Editing");
		else if ($status == 1)
			echo dPformSafe("Submitted"); // closed for normal users
		else if ($status == 2)
			echo dPformSafe("Approved");
	     ?>
	</td>
	<td nowrap="nowrap" width="20"> <?php
		if ($canDelete) {
			// call the edit site with the unique id of the timesheet item
			echo "\n".'<a href="?m=timesheet&a=addedit&timesheet_id=' . $row["timesheet_id"] . '">';
			echo dPshowImage( './images/icons/stock_delete-16.png', '16', '16' );
			echo "\n</a>";
		}
	     ?>
	</td>
</tr>
<?php
}
?>
</table>
<?php
} // end of function
?>
